package JavaML;

/**
 * An interface for representing a Classifier
 * 
 * @author apocock
 */
public interface IClassifier
{
  public static int positiveClass = 1;
  public static int negativeClass = -1;

  public IClassifier copyClassifier();
  
  public void setupClassifier(String arguments);

  public double train(IDataset trainingData, int iterations);
    
  //returns accuracy percentage
  public double test(IDataset testingData);
  
  public int[] classifyDataset(IDataset testingData);
  
  public int classifySample(double[] sample);
  
  public int[] getFeatureList();
  
  public boolean getIsTrained();
  
  public boolean supportsWeightedData();
  
  public boolean supportsMultiClassData();
}//public interface IClassifier
