package JavaML;

/**
 * An interface for representing a Dataset
 * It extends IOnlineDataset as it imposes several 
 * properties, such as the whole dataset 
 * being accesible at once.
 * 
 * @author apocock
 */
public interface IDataset extends IOnlineDataset
{

  public double[][] getDataMatrixDouble();
  public int[] getTargetVector();
  
  public double[] getSampleDouble(int sampleNumber, boolean hasTarget);
  
  public double[] getDataWeights();
  public void setDataWeights(double[] newWeights);
  public int getTotalWeight();
  
  public IDataset getDataFeatureSubset(int[] featuresRequired);
  
  public IDataset getDataSampleSubset(int[] samplesRequired);
  
  public IDataset getSampledDataset(double[] distributionOverFeatures, int sampleSize);

  public void splitIntoFolds(int numberOfFolds);
  
  public IDataset returnWeightedTrainingSet(int foldNumber);
  public IDataset returnWeightedTestingSet(int foldNumber);
  
  public IDataset returnSampledTrainingSet(int foldNumber, int sampleSize);
  public IDataset returnSampledTestingSet(int foldNumber, int sampleSize);
  
}//interface IDataset
