package JavaML;

/**
 * An interface for representing an Online Dataset
 * 
 * @author apocock
 */
public interface IOnlineDataset
{
  public enum DataType
  {
    Integer, Double
  }

  public enum FeatureType
  {
    Real, Categorical
  }

  public double[] getNextDataPoint();
  public int getNextTarget();
  
  public int returnCurrentDataSampleNumber();
  public int returnCurrentTargetSampleNumber();

  public void resetDataset();

  public void setRandomSeed(long newSeed);

  public DataType getDataType();

  public int getNumberOfFeatures();
  public int getNumberOfSamples();
  public boolean hasData();
}//interface IOnlineDataset
