import JavaML.*;

public class OnlineTest
{

  public static void main(String [] args)
  {
    int numLearners = 30;
    String trainName = args[0];
    //String outputName = args[1];
    //String variableOne = args[2];//"ExamplesBeforeBackwardStep";
    //String variableTwo = args[3];//"WindowSize";
    String variableOne = args[1];//"ExamplesBeforeBackwardStep";
    String variableTwo = args[2];//"WindowSize";
    String trainPath = "~/datasets/" + trainName;
    //String classifierName = "Online Boosting->NB";
    String classifierName = "ONSBoost->NB";

    IOnlineClassifier baseLearner = new NaiveBayes(true);
    
    //IOnlineClassifier boostedClassifier = new OnlineAdaBoost(numLearners,baseLearner,"",false);
    IOnlineClassifier boostedClassifier = new ONSBoost(numLearners,baseLearner,"");
    
    IDataset trainSet = new DatasetDouble(trainPath, false, false);

    String setupString = "ExamplesBeforeBackwardStep=" + variableOne + " " + "WindowSize=" + variableTwo;
    
    double[] errorValues = new double[10];
      
      
      IOnlineClassifier testRunClassifier = boostedClassifier.copyClassifier();
      testRunClassifier.setupClassifier(setupString);
      errorValues[0] = trainOnlineClassifier(trainSet,testRunClassifier);
    

    System.out.println(classifierName + " Error value = " + errorValues[0]);
    
    for (int i = 0; i < 9; i++)
    {
    	IOnlineClassifier temp = boostedClassifier.copyClassifier();
      	temp.setupClassifier(setupString);
      	errorValues[i+1] = trainOnlineClassifier(trainSet,temp);
    	System.out.println("Itr = " +  (i+1) + " " + classifierName + " Error value = " + errorValues[i+1]);
    }
    
    outputArray(errorValues);
	
  }//main
  
  
  public static void outputArray(double[] errorValues)
  {
    StringBuffer temp = new StringBuffer();
    
    for (int i = 0; i < errorValues.length-1; i++)
    {
      temp.append(errorValues[i]);
      temp.append(",");
    }
    temp.append(errorValues[errorValues.length-1]);
    
    System.out.println(temp.toString());
  }//outputArray(PrintWriter,double[])
  
  public static double trainOnlineClassifier(IDataset trainingData, IOnlineClassifier classifier)
  { 
    int errorCount = 0;
    int[] targets = trainingData.getTargetVector();
    for (int i = 0; i < trainingData.getNumberOfSamples(); i++)
    {
      double [] currentSample = trainingData.getSampleDouble(i,false);
      int trainedVal = classifier.classifySample(currentSample);
      classifier.onlineTrain(currentSample,targets[i]);
      if (trainedVal != targets[i])
      {
        errorCount++;
      }
    }
    return (double) errorCount / trainingData.getNumberOfSamples();
  }//trainOnlineClassifier(IDataset,IOnlineClassifier)  

}//class OnlineTest
